<?php

// $Id: socialscore.node.inc, $

/**
 * @file
 * Provides function for nodeapi operations.
 * Only one node per time.
 */

//get socialscore from database
function socialscore_get_socialscore(&$node) {
  return socialscore_node_get_recent_score($node);
}

//delete socialscore from table
function socialscore_delete_socialscore(&$node) {
  db_query('DELETE FROM {socialscore} WHERE nid = %d', $node->nid);
  return db_affected_rows();
}

//insert social score to database, 0 score this node has just been created!
function socialscore_insert_socialscore(&$node) {
  $current_timestamp = time();
  $score_expired = time()+ variable_get('socialscore_seconds', 60);
  db_query('INSERT INTO {socialscore} (nid, socialscore, timestamp, expired) VALUES(%d, %d, %d, %d)', $node->nid, 0, $current_timestamp, $score_expired);
  return db_affected_rows();
}

/**
 *
 * Return (updated)social score for a specific node
 *
 */
function socialscore_node_get_recent_score(&$node) {
  $time_now = time();
  $expiration_time_of_node = db_result(db_query('SELECT expired FROM {socialscore} WHERE nid = %d', $node->nid));
  if ($time_now > $expiration_time_of_node) {
    $nodes = array();
    $nodes[] = socialscore_prepare_data_request_for_node($node);
    socialscore_sychro_operation($nodes, TRUE, FALSE); //update = TRUE, massive = FALSE
    //drupal_set_message('SocialScore of node has been updated');
  }
  return db_result(db_query('SELECT socialscore FROM {socialscore} WHERE nid = %d', $node->nid));
}