<?php

// $Id: socialscore.sychro.inc, $

/**
 * @file
 * Synchro functions
 * Those functions run every time user runs the ajax-batch sychro, cron or node
 */


/**
 * Counts how many nodes need social sychronization
 *
 */
function socialscore_count_nodes_for_sychronization() {
  $active_content_types =  socialscore_get_active_content_types();
  if ($active_content_types) {
    $query_type_in = '(';
    foreach ($active_content_types as $active_content_type) {
      $query_type_in .= '"' . $active_content_type . '",';
    }
    $query_type_in .= ')';
    $query_type_in = str_replace(',)', ')', $query_type_in);
    return db_result(db_query('SELECT count(nid) FROM {node} WHERE type in ' . $query_type_in . ' AND status <> %d ', 0));
  }
  else return 0;
}

/**
 *
 */
function socialscore_get_nodes_to_sycronize($query_seek) {

  //empty the table
  if ($query_seek == 0) db_query('TRUNCATE TABLE {socialscore}');

  global $base_url;

  $operations = array();
  $url_category = variable_get('socialscore_alias', 'noalias');

  //get active content types
  $active_content_types =  socialscore_get_active_content_types();
  if ($active_content_types) {
    $query_type_in = '(';
    foreach ($active_content_types as $active_content_type) {
      $query_type_in .= '"' . $active_content_type . '",';
    }
    $query_type_in .= ')';
    $query_type_in = str_replace(',)', ')', $query_type_in);
    $query = db_query('SELECT nid, type FROM {node} WHERE type in ' . $query_type_in . ' AND status <> %d ORDER BY nid ASC LIMIT %d, %d', 0, $query_seek, variable_get('socialscore_sql_limit', 500));
  }

  while ($row = db_fetch_object($query)) {
    $null_obj = new stdClass();
    $nodes[] = socialscore_prepare_data_request_for_node($null_obj, $row->nid);
  }

  return $nodes;

}

/**
 * This function is the operation of the batch
 * It creates socialscore_score_data objects, from database affected nid which have been expired
 */
function socialscore_sychro_operation(&$nodes, $update = FALSE, $massive_synchro = TRUE)  {//pass an array of nodes
  //empty array return
  if (!$nodes || (count(socialscore_get_active_socialscore_submodules()) == 0)) return;
  foreach ($nodes as $node) {
    //create the urls array
    if ($node->path) {
      $urls[$node->nid][] = $node->path;
    }
    if ($node->alias) {
      $urls[$node->nid][] = $node->alias;
    }
  }
  
  //massive request for performance reasons
  if (!$massive_synchro) $results = socialscore_socialscore_core_request(socialscore_get_active_socialscore_submodules(), $urls);
  else {
    if (count(socialscore_get_synchro_recommened_submodules()) == 0) return ; //nothing to do
    $results = socialscore_socialscore_core_request(socialscore_get_synchro_recommened_submodules(), $urls);
  }

  foreach ($urls as $nid => $path) {

    $socialscore = 0;

    $votes[$nid] = array(
      'nid' => $nid,
      'expired' => time()+ variable_get('socialscore_seconds', 60),
      'timestamp' => time(),
      'socialscore' => $socialscore,
    );
    foreach ($path as $url) {
      if (!$results[$url]) {
        watchdog('SocialScoreVotesError', 'error@ line 95 socialscore.sychro.inc. No score for ' . $url);
      }
      else {
        foreach ($results[$url] as $field => $score) {
		  $votes[$nid][$field] = (isset($votes[$nid][$field])) ? ($votes[$nid][$field]+intval($score)) : intval($score); //bug fix (alpha1) create the array with the votes foreach filed with the corresponding value
          if (socialscore_is_enabled_field($field)) $socialscore += intval($score); //sum the social score, if feature is enabled [add only enabled fields]
        }
      }//else no error
    }
    $votes[$nid]['socialscore'] = $socialscore;
	
    $db_values = array_keys($votes[$nid]);
    $db_scores = array_values($votes[$nid]);
    //todo description.... the most complex code block!!!
    if ($massive_synchro) {
	  $saved_score_results = db_query('SELECT * FROM {socialscore} WHERE nid = %d', $nid);
      if(db_affected_rows() == 0) db_query('INSERT INTO {socialscore} ('. implode(',', $db_values) .') VALUES ('. implode(',', $db_scores) .')');
      else {
	    $update_query = '';
		$semi_updated_socialscore = 0;
        for($i=0; $i<count($db_values); $i++) {
		  if (($db_values[$i] != 'socialscore') && ($db_values[$i] != 'nid')) {
            $update_query .= ' ' . $db_values[$i] . '=' . $db_scores[$i] . ' ,';
		    if (($db_values[$i] != 'nid') && ($db_values[$i] != 'expired') && ($db_values[$i] != 'timestamp') && (socialscore_is_enabled_field($db_values[$i]))) $semi_updated_socialscore += $db_scores[$i];
          }
		}
		while ($row = db_fetch_array($saved_score_results)) { //active fields which can not syncro by massive requests
		  foreach(array_keys($row) as $row_field) {
			if (socialscore_is_enabled_field($row_field) && (!isset($votes[$nid][$row_field])))  $semi_updated_socialscore += $row[$row_field];
		  }
		}
        $update_query .= ' socialscore = ' . $semi_updated_socialscore . ' ';
		db_query('UPDATE {socialscore} SET ' . $update_query . ' WHERE nid = %d', $nid);
	  }
    }
	else {//not massive request
	  if ($update) {
        db_query('DELETE FROM {socialscore} WHERE nid = %d', $nid);
        db_query('INSERT INTO {socialscore} ('. implode(',', $db_values) .') VALUES ('. implode(',', $db_scores) .')');
	  }
      else db_query('INSERT INTO {socialscore} ('. implode(',', $db_values) .') VALUES ('. implode(',', $db_scores) .')');
	}

  }

}

/**
 *
 *
 *
 */
function socialscore_ajax_operation() {
  //check plain for security reasons
  $socialscore_posted_key = check_plain($_POST['socialscore_key']);//md5 key
  $socialscore_query_seek = check_plain($_POST['socialscore_qseek']);//query limit

  if ( (variable_get('socialscore_key', drupal_get_token('nothing'))) != $socialscore_posted_key) {
    print t('Wrong Key');
  }
  elseif ( (variable_get('socialscore_key', '123456789012345') == $socialscore_posted_key) && $socialscore_query_seek >= 0 ) {
    $nodes = socialscore_get_nodes_to_sycronize($socialscore_query_seek);
    socialscore_sychro_operation($nodes);
    print t('OK');
  }
  else print t('Bad Request');
}