<?php

// $Id: Social Score Delicious  $

/**
 * @file
 */

/**
 * Implementation of hook_form().
 */
function socialscore_delicious_form(&$form) {

  $form = array();

  $form['socialscore_delicious_attributes'] = array(
    '#type' => 'checkboxes',
    '#title' => t('Which features to count'),
    '#options' => array(
      'delicious_totalCount' => t('Delicious total count'),
    ),
    '#default_value' => variable_get('socialscore_delicious_score_active_features' , array('')),
    '#description' => t('Enable the features, you would like to count from Delicious API.'),
  );
  
  $form['submit'] = array(
    '#type' => 'submit',
    '#value' => t('Go'),
  );
  
  return $form;
}

/**
 * Implementation of hook_form_alter.
 */
function socialscore_delicious_form_alter(&$form, &$form_state, $form_id) {
  socialscore_clear_views_cache();
}


/**
 * Implementation of hook_form_validate().
 */
function socialscore_delicious_form_validate(&$form, $form_values) {
  //nothing to do
}

/**
 * Submit handler for the facebook admin settings form.
 */
function socialscore_delicious_form_submit(&$form, $form_values) {
  variable_set('socialscore_delicious_score_active_features', $form_values['values']['socialscore_delicious_attributes']);
  drupal_set_message(t('Your settings have been saved.'));
  drupal_set_message(t('You have made changes at social score settings. Please run the ') . l(t('sychronization batch.'), 'admin/settings/social-score/synchronization'), 'warning');
}
