<?php

// $Id: Social Score Facebook  $

/**
 * @file
 */

/**
 * Implementation of hook_form().
 */
function socialscore_facebook_form(&$form) {

  $form = array();

  $form['socialscore_facebook_info_msg'] = array(
    '#type' => 'markup',
    '#value' => '<div class="socialscore-facebook-msg"><strong><p>' . t('We use the ') . l('Facebook FQL language', 'http://developers.facebook.com/docs/reference/fql/') . t(' of Facebook.') . '<br />' . t('It provides for some advanced features not available in the Graph API, including batching multiple queries into a single call.') . '</p></strong>',
  );

  /*$form['socialscore_facebook_api_field'] = array(
    '#type' => 'textfield',
    '#title' => t('Facebook url API'),
    '#default_value' => variable_get('socialscore_facebook_score_api_url', 'http://api.facebook.com/restserver.php?method=links.getStats&urls='),
    '#required' => TRUE,
    '#description' => t('The Facebook URL API to send xml requests'),
  );*/
  
  $form['socialscore_facebook_attributes'] = array(
    '#type' => 'checkboxes',
    '#title' => t('Which features to count'),
    '#options' => array(
      'fb_shareCount' => t('Count Facebook Share'),
      'fb_likeCount' => t('Count Facebook Likes'),
      'fb_commentCount' => t('Count Facebook Comments'),
      'fb_commentsboxCount' => t('Count Facebook Comments box'),
    ),
    '#default_value' => variable_get('socialscore_facebook_score_active_features' , array('')),
    '#description' => t('Enable the features, you would like to count from Facebook API.'),
  );

  $details_message = '<li>' . t('Share count: The number of times users have shared the page on Facebook.') . '</li>';
  $details_message .= '<li>' . t('Like count: The number of times Facebook users have "Liked" the page, or liked any comments or re-shares of this page.') . '</li>';
  $details_message .= '<li>' . t('Comment count: The number of comments users have made on the shared story.') . '</li>';
  $details_message .= '<li>' . t('Comments box count: The number of comments from a comments box on this URL. This only includes top level comments, not replies.') . '</li>';
  $form['socialscore_facebook_info_details'] = array(
    '#type' => 'markup',
    '#value' => '<div class="socialscore-facebook-msg"><ul>' . $details_message . '</ul>',
  );
  
  $form['submit'] = array(
    '#type' => 'submit',
    '#value' => t('Go'),
  );
  
  return $form;
}

/**
 * Implementation of hook_form_alter.
 */
function socialscore_facebook_form_alter(&$form, &$form_state, $form_id) {
  socialscore_clear_views_cache();
}


/**
 * Implementation of hook_form_validate().
 */
function socialscore_facebook_form_validate(&$form, $form_values) {
  //nothing to do
}

/**
 * Submit handler for the facebook admin settings form.
 */
function socialscore_facebook_form_submit(&$form, $form_values) {
  variable_set('socialscore_facebook_score_active_features', $form_values['values']['socialscore_facebook_attributes']);
  //variable_set('socialscore_facebook_score_api_url', $form_values['values']['socialscore_facebook_api_field']);
  drupal_set_message(t('Your settings have been saved.'));
  drupal_set_message(t('You have made changes at social score settings. Please run the ') . l(t('sychronization batch.'), 'admin/settings/social-score/synchronization'), 'warning');
}
